#  Algorithme de dichotomie


def cherche(tableau, x):
    """
    Cherche l'index dans le tableau de la valeur x
    entrée en paramètre.
    Cette valeur est obligatoirement dans le tableau.
    
    Paramètres
    ----------
        tableau : de type liste d'entiers
        x : de type entier
        
    Retourne
    --------
        m : de type entier
           C'est l'index de la valeur.
        
    """
    
    assert x in tableau, "x doit être dans le tableau"
    
    debut = 0
    fin = len(tableau)  
    
    valeur_trouve = False  #  Passera à True lorsque
                           #  valeur sera trouvée.

    compteur = 0  # sert à afficher le nombre de tours de boucle while.
                           
    while valeur_trouve == False and debut < fin:
        compteur += 1
        m = (debut + fin) // 2
        if tableau[m] == x:
            valeur_trouve = True
        else:
            if x < tableau[m]:
                fin = m
            else:
                debut = m
    return m, compteur
    

ma_liste_triee =  [11, 30, 42, 43, 66, 68, 85, 93,\
98, 111, 127, 128, 138, 155, 160, 160, 161, 174, 178,\
208, 231, 238, 250, 254, 259, 262, 265, 270, 272,\
285, 292, 302, 309, 351, 352, 358, 368, 381, 382, 397,\
410, 416, 447, 447, 448, 449, 471, 471, 487, 495, 513,\
516, 540, 544, 557, 557, 572, 590, 601, 602, 613, 615,\
627, 633, 633, 635, 658, 662, 682, 686, 698, 702, 711,\
725, 727, 747, 771, 777, 780, 800, 804, 806, 810, 852,\
852, 856, 861, 873, 876, 887, 893, 927, 931, 935, 966,\
971, 975, 984, 996, 999]

ma_liste_avec_index = [couple for couple in enumerate(ma_liste_triee)]


def generer_liste_triee(maximum):
    """
    Génère le liste de tous les entiers dans l'ordre croissant entre
    0 et maximum.
    
    Paramètre :
    ----------
        maximum : de type entier.
            C'est la valeur maximale de la liste.
                  
    Revoie :
    --------
        liste : de type liste
        
    """
    
    liste = [i for i in range(maximum+1)]
    return liste

liste_triee = generer_liste_triee(50000)

index, nbTours = cherche(liste_triee, 50000)
    
print(index, nbTours)    